/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : CCMFrameLoader                                                *
 * Package : zeus                                                          *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/25 09:22:03 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: CCMFrameLoader.h,v $
 *   Revision 1.2  2005/11/25 09:22:03  bhadorn
 *   Reading and parsing the application parameters before loading the framework
 *
 *   Revision 1.1  2005/10/28 12:09:54  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CCMFrameLoaderH
#define CCMFrameLoaderH

#include <zeusbase/AbstractFrameLoader.h>

BEGIN_NAMESPACE_Zeus

class TAppParamReader;
class TApplication;

/***************************************************************************/
/*! Die Klasse FrameLoader ist zustaendig das Framework zu initialisieren
    und die Modul Object Model Struktur aufzubauen.
*/
/***************************************************************************/
class TCCMFrameLoader : public TAbstractFrameLoader
{
  public:
    //Konstruktor
    TCCMFrameLoader(int argc, char *argv[]);

    bool canStartup();
    virtual void initialize();
    virtual long run();
    virtual unsigned long startup();
    virtual unsigned long shutdown();

  protected:
    virtual ~TCCMFrameLoader();
//    virtual void loadPropertyFile(const TString& filename);
    
  private:
    ///Application Parameter Reader
    TAppParamReader* m_pAppParameter;
    ///Application reference
    TApplication* m_pApplication;
};

END_NAMESPACE_Zeus

#endif
