/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : InputCell                                                  *
 * Package : Test Module for Cell Computing                                *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:09:54 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: InputCell.cpp,v $
 *   Revision 1.1  2005/10/28 12:09:54  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 

#include <InputCell.h> 
#include <zeusbase/System/LoggerManager.h>
#include <zeusbase/System/SingleLinkedList.hpp>
#include <zeusbase/System/ServerSocket.h>
#include <zeusbase/Messaging/XMLMessage.h>

USING_NAMESPACE_Zeus

/***************************************************************************/
/*! Creates an input cell
*/
/***************************************************************************/
TInputCell::TInputCell(IXMLNode* node) : TAbstractCell(node)
{
}

/***************************************************************************/
/*! Destroys the input cell
*/
/***************************************************************************/
TInputCell::~TInputCell()
{
}


/***************************************************************************/
/*! See ICellKernel
*/
/***************************************************************************/
void TInputCell::onInitialLife()
{
}

/***************************************************************************/
/*! See ICellKernel
*/
/***************************************************************************/
void TInputCell::onEndLife()
{
}



/***************************************************************************/
/*! See ICellKernel
*/
/***************************************************************************/
void TInputCell::sendLifeSignal()
{  
  
  if (m_pCommunication != NULL)
  {
    IXMLMessage* pMessage = NULL;
    if (TXMLMessage::createMessage(L"MessageObject", L"WorkCell", PIPENAME_STDIN, &pMessage) == RET_NOERROR)
    {
      if (m_pCommunication->sendMessage(pMessage, 0) == RET_NOERROR)
      {
        ZLOGGER.printfln(LOGMODE_DEBUG,"Message sent.");
      }
      else
      {
        ZLOGGER.printfln(LOGMODE_DEBUG,"Message sent failed.");
      }
      pMessage->release();
    }

    TTime::usleep(20000); //20ms
  }
}
