/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : InputCell                                                  *
 * Package : Test Module for Cell Computing                                *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:09:54 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: InputCell.h,v $
 *   Revision 1.1  2005/10/28 12:09:54  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 

#ifndef InputCellH
#define InputCellH

#include <zeusdev/AbstractCell.h>
#include <zeusbase/System/XObjectFactory.h>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! The input cell receives commands throu a terminal
*/
/***************************************************************************/
class TInputCell : public TAbstractCell
{
  public:
    TInputCell(IXMLNode* node);
    
    REG_SUB_BEGIN(TInputCell)
    REG_SUB_ADD(TInputCell, L"TInputCell");
    REG_SUB_END
    
    virtual void sendLifeSignal();

  protected:    
    virtual ~TInputCell();
    
  private:
    
    virtual void onInitialLife();
    virtual void onEndLife();
};

END_NAMESPACE_Zeus

#endif 
