/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : WorkCell                                                      *
 * Package : Test Module for Cell Computing                                *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:09:54 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: WorkCell.h,v $
 *   Revision 1.1  2005/10/28 12:09:54  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 

#ifndef WorkCellH
#define WorkCellH

#include <zeusdev/AbstractCell.h>
#include <zeusbase/System/XObjectFactory.h>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Defines a simple work cell. The cell only processes cell system messages
    CSMessages.
*/
/***************************************************************************/
class TWorkCell : public TAbstractCell
{
  public:
    TWorkCell(IXMLNode* node);
    
    REG_SUB_BEGIN(TWorkCell)
    REG_SUB_ADD(TWorkCell, L"TWorkCell");
    REG_SUB_END

  protected:
    virtual ~TWorkCell();
    virtual void performXMLMessage(IXMLMessage* msg, unsigned long long timer);
};

END_NAMESPACE_Zeus

#endif 
