/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : genetic_test                                                  *
 * Package : examples                                                      *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:11:00 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: ExIndividual.h,v $
 *   Revision 1.1  2005/10/28 12:11:00  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ExIndividualH 
#define ExIndividualH

#include <zeusbase/Math/GAIndividual.h>
#include <zeusbase/System/ArrayList.hpp>
#include <TravellingSalesMan.h>

BEGIN_NAMESPACE_Zeus

class TGAChromosone;

/***************************************************************************/
/*! Example Individual. It implements only the way how the fitness shoul be 
    estaminated.
*/
/***************************************************************************/
class TExIndividual : public TGAIndividual
{
  public:
    TExIndividual(TTravellingSalesMan& salesman);
    
    //Methods of IGAIndividual
    virtual double MQUALIFIER getFitness();
    virtual void MQUALIFIER createChromosones();

    static void crossAlgo(TArrayList<long>& lstGenesA, TArrayList<long>& lstGenesB, TArrayList<long>& lstNewGene);

  protected:
    virtual ~TExIndividual();
    
  private:
    ///Travelling sales man object
    TTravellingSalesMan& m_SalesMan;
    
    static unsigned long customCrossFunction(IGAChromosone* parent1, 
                                             IGAChromosone* parent2, 
                                             TGAChromosone* new_chrom1, 
                                             TGAChromosone* new_chrom2);

    static long findUnvisitedCity(TArrayList<bool> mark, long index);
    static long findCity(TArrayList<long>& lst, long value);

};


END_NAMESPACE_Zeus

#endif
