

#ifndef IMandelbrotFrameHPP 
#define IMandelbrotFrameHPP

#include <zeusbase/System/Interfaces/ISerializable.hpp>
#include <zeusbase/System/Interfaces/IByteArray.hpp>

BEGIN_NAMESPACE_Zeus

#define MTYPE_MANDELBROT     17443

class IMandelbrotFrame : public ISerializable
{
  public:
    virtual long MQUALIFIER getX1() const=0;
    virtual long MQUALIFIER getY1() const=0;
    virtual long MQUALIFIER getX2() const=0;
    virtual long MQUALIFIER getY2() const=0;
    virtual long MQUALIFIER getMaxRange() const=0;
    virtual long MQUALIFIER getIterations() const=0;
    virtual double MQUALIFIER getCenterX() const=0;
    virtual double MQUALIFIER getCenterY() const=0;
    virtual double MQUALIFIER getScale() const=0;
    virtual double MQUALIFIER getTimeStamp() const=0;
    virtual unsigned long MQUALIFIER getData(IList<double>** data)=0;
    
};

END_NAMESPACE_Zeus

#endif

