/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : QTFrameLoader                                                 *
 * Package : mandelbrot                                                    *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/25 09:19:27 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: QTFrameLoader.h,v $
 *   Revision 1.1  2005/11/25 09:19:27  bhadorn
 *   Created
 *
 *   Revision 1.1  2005/10/28 12:11:50  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef QTFrameLoaderH
#define QTFrameLoaderH

#include <zeusbase/AbstractFrameLoader.h>
#include <qapplication.h>

//forward decls
class TMainForm;

BEGIN_NAMESPACE_Zeus

class TCommandDispatcher;

/***************************************************************************/
/*! Die Klasse FrameLoader ist zustaendig das Framework zu initialisieren
    und die Modul Object Model Struktur aufzubauen.
*/
/***************************************************************************/
class TQTFrameLoader : public TAbstractFrameLoader
{
  public:
    //Konstruktor
    TQTFrameLoader(int& argc, char** argv);

    bool canStartup();
    virtual long run();
    virtual unsigned long startup();
    virtual unsigned long shutdown();

  protected:
    virtual ~TQTFrameLoader();
    
  private:
    //Command dispatcher of the gui gateway
    TCommandDispatcher* m_pDispatcher;
    ///QT Application object
    QApplication m_Application;
    ///Main form
    TMainForm* m_pMainForm;
};

END_NAMESPACE_Zeus

#endif
