/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#include <qfiledialog.h>

/***************************************************************************/
/*! Loads a movie file into the application 
*/
/***************************************************************************/
void TMainForm::onLoadButtonClicked()
{
  bool bLoaded = false;
  QString strFileName = QFileDialog::getOpenFileName(QString::null, QString::null, this);
  if (!strFileName.isEmpty() && m_pDispatcher != NULL)
  {
    if (m_pDispatcher->loadMovieFile(_QTWSTR(strFileName), 
                                     m_lFrameCount) == RET_NOERROR)
    {
      bLoaded  = true;
    }
  }
  
  //Show filename if file has been loaded
  if (bLoaded)
  {
    m_lbFileName->setText(strFileName);
    m_btnStopButton->setEnabled(false);
    m_btnStartButton->setEnabled(true);
    m_chkVector->setEnabled(true);
    m_pnMovieProgress->setProgress(0);
    m_pnMovieProgress->setTotalSteps(m_lFrameCount);
  }
}


/***************************************************************************/
/*!Sets the command dispatcher witch is needed to dispatch the gui commands to the 
    cell system
*/
/***************************************************************************/
void TMainForm::setCommandDispatcher( NAMESPACE_Zeus::TCommandDispatcher * cmd )
{
  if (m_pDispatcher != NULL)
  {
    m_pDispatcher->release();
  }
  m_pDispatcher = cmd;
  if (m_pDispatcher != NULL)
  {
    m_pDispatcher->addRef();
    m_pDispatcher->setOriginalDisplay(m_pOriginalDisplay);
    m_pDispatcher->setMotionDisplay(m_pMotionDisplay);
    m_pDispatcher->setProgressBar(m_pnMovieProgress);
    m_pDispatcher->setTimeLabel(m_lbTime);
  }
}


/***************************************************************************/
/*! This method must be called at the beginning. All customized variables will be initialised
*/
/***************************************************************************/
void TMainForm::unfreeze()
{
  m_lFrameCount = 0;
  m_pOrigLayout = new QVBoxLayout( m_pnOrig, 1, 1, "m_pOrigLayout");  
  m_pMotionLayout = new QVBoxLayout( m_pnMotion, 1, 1, "motionlayout"); 
  m_pOrigScroller = new QScrollView(m_pnOrig, "origscroller");
  m_pMotionScroller = new QScrollView(m_pnMotion, "motionscroller");
  
  m_pOriginalDisplay = new TMovieDisplay(m_pOrigScroller, "m_pOriginalDisplay");
  m_pMotionDisplay = new TMovieDisplay(m_pMotionScroller, "moviedisplay");
  
  m_pOrigScroller->addChild(m_pOriginalDisplay );
  m_pMotionScroller->addChild(m_pMotionDisplay );
  
  m_pOrigLayout ->addWidget(m_pOrigScroller);
  m_pMotionLayout ->addWidget(m_pMotionScroller);
  
  m_btnStopButton->setEnabled(false);
  m_btnStartButton->setEnabled(false);
  m_chkVector->setEnabled(true);
  m_pnMovieProgress->setProgress(50);
  m_pDispatcher = NULL;
}


/***************************************************************************/
/*! This method must be called at the end. All customized variables will be removed
*/
/***************************************************************************/
void TMainForm::freeze()
{
  if (m_pDispatcher != NULL)
  {
    m_pDispatcher->setOriginalDisplay(NULL);
    m_pDispatcher->setMotionDisplay(NULL);
    m_pDispatcher->setProgressBar(NULL);
    m_pDispatcher->release();
    m_pDispatcher = NULL;
  }
//  delete m_pOrigLayout;
//  delete m_pMotionLayout;
//  delete m_pOrigScroller;
//  delete m_pMotionScroller;
}


/***************************************************************************/
/*! Starts the movie
*/
/***************************************************************************/
void TMainForm::onStartButtonClicked()
{
  if (m_pDispatcher != NULL && m_pDispatcher ->onStart() == RET_NOERROR)
  {
    m_btnStartButton->setEnabled(false);
    m_btnStopButton->setEnabled(true);
    m_chkVector->setEnabled(false);
  }
}


/***************************************************************************/
/*! Stopps the movie
*/
/***************************************************************************/
void TMainForm::onStopButtonClicked()
{
  if (m_pDispatcher != NULL && m_pDispatcher ->onStop() == RET_NOERROR)
  {
    m_btnStopButton->setEnabled(false);
    m_btnStartButton->setEnabled(true);
  }
}


/***************************************************************************/
/*! changes the vector mode
*/
/***************************************************************************/
void TMainForm::onVectorToggled( bool value)
{
  if (m_pDispatcher != NULL)
  {
    m_pDispatcher->changeToVector(value);
  }
}
