/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : modec                                                         *
 * Module  : BlockMatchCell                                                *
 * Package : MotionDetectModule                                            *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/12/14 09:22:55 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: BlockMatchCell.h,v $
 *   Revision 1.2  2005/12/14 09:22:55  bhadorn
 *   Redesing of the motion detection module
 *
 *   Revision 1.1  2005/10/28 12:11:49  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef BlockMatchCellH
#define BlockMatchCellH

#include <zeusdev/AbstractCell.h>
#include <zeusbase/System/XObjectFactory.h>

BEGIN_NAMESPACE_Zeus

class IDIBFragment;
class IDIBFrame;

/***************************************************************************/
/*! This cell processes fragments of a movie frame to detect movements.
    It uses the block matching algorithme to do so.
*/
/***************************************************************************/
class TBlockMatchCell : public TAbstractCell
{
  public:
    TBlockMatchCell(IXMLNode* node);
    
    REG_SUB_BEGIN(TBlockMatchCell)
    REG_SUB_ADD(TBlockMatchCell, L"TBlockMatchCell");
    REG_SUB_END

  protected:
    virtual ~TBlockMatchCell();
    virtual void performObjectMessage(IObjectMessage* msg, unsigned long long timer);
    virtual void onInitialLife();
    virtual void onEndLife();
  
  private:
    ///Bias for detection
    double m_dBias;
    
    void doMatchBlock(long index, IDIBFragment* fragment);
    void ssd(IDIBFrame* frame1, IDIBFrame* frame2, long baseX, long baseY, long block_size, long max_move, long& x, long& y);
    
    
};

END_NAMESPACE_Zeus

#endif 
 
 
