/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : modec                                                         *
 * Module  : DifferenceCell                                                *
 * Package : MotionDetectModule                                            *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:11:49 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: DifferenceCell.h,v $
 *   Revision 1.1  2005/10/28 12:11:49  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef DifferenceCellH
#define DifferenceCellH

#include <zeusdev/AbstractCell.h>
#include <zeusbase/System/XObjectFactory.h>

BEGIN_NAMESPACE_Zeus

class IDIBFrame;

/***************************************************************************/
/*! Defines a simple work cell. The cell only processes cell system messages
    CSMessages.
*/
/***************************************************************************/
class TDifferenceCell : public TAbstractCell
{
  public:
    TDifferenceCell(IXMLNode* node);
    
    REG_SUB_BEGIN(TDifferenceCell)
    REG_SUB_ADD(TDifferenceCell, L"TDifferenceCell");
    REG_SUB_END

  protected:
    virtual ~TDifferenceCell();
    virtual void performObjectMessage(IObjectMessage* msg, unsigned long long timer);
    virtual void performXMLMessage(IXMLMessage* msg, unsigned long long timer);
    virtual void onInitialLife();
    virtual void onEndLife();
  
  private:
    //Last frame do create the difference
    IDIBFrame* m_pLastFrame;
};

END_NAMESPACE_Zeus

#endif 
 
 
