/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : modec                                                         *
 * Module  : MotionDetectModule                                            *
 * Package : MotionDetectModule                                            *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/12/14 09:22:56 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: MotionDetectModule.cpp,v $
 *   Revision 1.2  2005/12/14 09:22:56  bhadorn
 *   Redesing of the motion detection module
 *
 *   Revision 1.1  2005/10/28 12:11:49  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include <stdio.h> 
#include <examples/motiondetect/MotionDetectModule/BlockMatchCell.h>
#include <examples/motiondetect/MotionDetectModule/DifferenceCell.h>
#include <examples/motiondetect/MotionDetectModule/ModecInputCell.h>
#include <examples/motiondetect/MotionDetectModule/ModecOutputCell.h>
#include <examples/motiondetect/MotionDetectModule/DIBFrame.h>
#include <examples/motiondetect/MotionDetectModule/DIBBlock.h>
#include <examples/motiondetect/MotionDetectModule/DIBFragment.h>
#include <zeusbase/System/XObjectFactory.h>
#include <zeusbase/System/LibraryManager.h>
#include <zeusdev/AbstractModuleSession.h>

USING_NAMESPACE_Zeus

///////////////////////////////////////////////
// Exported Factories
//MExportObjectFactory(IModuleSession, TInputModuleSession);
MExportXObjectFactory(TBlockMatchCell);
MExportXObjectFactory(TDifferenceCell);
MExportXObjectFactory(TModecOutputCell);
MExportXObjectFactory(TModecInputCell);
///////////////////////////////////////////////

MregisterLibrary_Start(L"MotionDetectModule");
  OBJECTFACTORY_REGISTER_CLASS(NAMESPACE_Zeus::TDIBFrame);
  OBJECTFACTORY_REGISTER_CLASS(NAMESPACE_Zeus::TDIBBlock);
  OBJECTFACTORY_REGISTER_CLASS(NAMESPACE_Zeus::TDIBFragment);
MregisterLibrary_End;

MunregisterLibrary();

 
