/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : LogModuleSessionH                                             *
 * Package : LOG_Service                                                   *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:13:11 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: LogModuleSession.cpp,v $
 *   Revision 1.1  2005/10/28 12:13:11  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <LogModuleSession.h>
#include <ZeusLogger.h>
#include <log4cxx/basicconfigurator.h>

USING_NAMESPACE_Zeus

using namespace log4cxx;
using namespace log4cxx::helpers;


/***************************************************************************/
/*! Creates the TestModulFactory
*/
/***************************************************************************/
TLogModuleSession::TLogModuleSession() : TAbstractModuleSession()
{
}


/***************************************************************************/
/*! Destroyes the TestModulFactory
*/
/***************************************************************************/
TLogModuleSession::~TLogModuleSession()
{}


/***************************************************************************/
/*! see IModulFactory
*/
/***************************************************************************/
unsigned long MQUALIFIER TLogModuleSession::createObjectOfModule(unsigned long interface_id, IZUnknown** iface)
{
  unsigned long ulRetval = RET_NOERROR;
  if(iface == NULL)
  {
    ulRetval = RET_INVALID_PARAMETER;
  }
  else
  {
    switch(interface_id)
    {
      case INTERFACE_ILogger :
        *iface = (ILogger*) new TZeusLogger();
        ulRetval = RET_NOERROR;
      break; 
      
      default:
        ulRetval = RET_INVALID_PARAMETER;
    }
  } 
  return ulRetval;
}
