/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : ZeusLogger                                                    *
 * Package : LOG_Service                                                   *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:13:11 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: ZeusLogger.h,v $
 *   Revision 1.1  2005/10/28 12:13:11  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ZeusLoggerH 
#define ZeusLoggerH

#include <zeusbase/System/String.h>
#include <zeusbase/System/ZObject.h>
#include <zeusbase/System/Interfaces/ILogger.hpp>
#include <log4cxx/logger.h>


BEGIN_NAMESPACE_Zeus

class TZeusLogger : public TZObject, public ILogger
{
  public:
    TZeusLogger(TString name = L"");

    //Interface ILogger 
    virtual unsigned long MQUALIFIER getLogger(IString* name, ILogger** logger);
    virtual unsigned long MQUALIFIER printDebug(IString* message);
    virtual unsigned long MQUALIFIER printError(IString* message);
    virtual unsigned long MQUALIFIER printFatal(IString* message);
    virtual unsigned long MQUALIFIER printInfo(IString* message);
    virtual unsigned long MQUALIFIER printWarn(IString* message);
    virtual bool MQUALIFIER isDebugEnabled();
    virtual bool MQUALIFIER isErrorEnabled();
    virtual bool MQUALIFIER isFatalEnabled();
    virtual bool MQUALIFIER isInfoEnabled();
    virtual bool MQUALIFIER isWarnEnabled();
    virtual unsigned long MQUALIFIER loadConfiguration(IString* file);
    virtual unsigned long MQUALIFIER loadProperties(IPropertyAccess* prop);

    //Methods of IZUnknown
    MEMORY_MANAGER_DECL

  protected:
    virtual ~TZeusLogger();

  private:
    ///Logger instance
    log4cxx::LoggerPtr m_Logger;
  
  
};


END_NAMESPACE_Zeus
#endif
