/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : NameServer                                                    *
 * Package : NameServer                                                    *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 11:05:49 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: NameServer.h,v $
 *   Revision 1.1  2005/11/10 11:05:49  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 
 
#ifndef NameServerH
#define NameServerH

#include <zeusbase/System/XObject.h>
#include <zeusbase/System/XObjectFactory.h>

BEGIN_NAMESPACE_Zeus

class TNaming_Skel;

/***************************************************************************/
/*! The regmanager controls the entries of the registry.
*/
/***************************************************************************/
class TNameServer : public TXObject
{
  public :
    TNameServer(IXMLNode* node);
    
    //Methods of IModule
    virtual bool MQUALIFIER freeze();
    virtual bool MQUALIFIER unfreeze();
    
    REG_SUB_BEGIN(TNameServer)
    REG_SUB_ADD(TNameServer, L"TNameServer");
    REG_SUB_END
    
    //Methods of IZUnknown
    MEMORY_MANAGER_DECL

  protected:  
    virtual ~TNameServer();
    
  private:
    ///Listen to the incomming requests
    TNaming_Skel* m_pSkeleton;
};

END_NAMESPACE_Zeus

#endif
