/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : XMLDocument                                                   *
 * Package : XML_Service                                                   *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:13:11 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: XMLDocument.h,v $
 *   Revision 1.1  2005/10/28 12:13:11  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef XMLDocumentH
#define XMLDocumentH

#ifndef LINUX
  #include <mem.h>
#endif

#include <xercesc/dom/DOM.hpp>
#include <xercesc/util/XercesDefs.hpp>
#include <zeusbase/System/String.h>
#include <zeusbase/System/ZObject.h>
#include <zeusbase/System/Interfaces/IXMLDocument.hpp>


XERCES_CPP_NAMESPACE_USE
BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! This class manages the parsed xml document
*/
/***************************************************************************/
class TXMLDocument : public TZObject, public IXMLDocument
{
  public:
    TXMLDocument(XERCES_CPP_NAMESPACE::DOMDocument* docu, TString filename);

    //Methods of IXMLDocument
    virtual unsigned long MQUALIFIER getMainNode(IXMLNode** main);
    virtual unsigned long MQUALIFIER getStream(IString* stream);
    virtual unsigned long MQUALIFIER save();
    virtual unsigned long MQUALIFIER saveAs(IString* filename);
    virtual unsigned long MQUALIFIER createNewNode(unsigned long node_type,
                                        IString* name,
                                        IString* uri,
                                        IXMLNode** node);


    //Methods of IZUnknown
    MEMORY_MANAGER_DECL

  protected:
    virtual ~TXMLDocument();

  private:
    ///Dokument
    XERCES_CPP_NAMESPACE::DOMDocument* m_pDocument;
    ///Name des Dokuments
    TString m_strFileName;

};

END_NAMESPACE_Zeus

#endif
