/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : XMLModuleSession                                              *
 * Package : XML_Service                                                   *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/25 10:16:21 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: XMLModuleSession.cpp,v $
 *   Revision 1.2  2005/11/25 10:16:21  bhadorn
 *   pragma only supported by borland compiler
 *
 *   Revision 1.1  2005/10/28 12:13:11  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <XMLModuleSession.h>
#include <XMLParser.h>

#ifdef LINUX

#else
  #pragma warn -8080
#endif

XERCES_CPP_NAMESPACE_USE

USING_NAMESPACE_Zeus

/***************************************************************************/
/*! Creates the session of the XML Module
*/
/***************************************************************************/
TXMLModuleSession::TXMLModuleSession() : TAbstractModuleSession()
{}


/***************************************************************************/
/*! Creates the session of the XML Module
*/
/***************************************************************************/
TXMLModuleSession::~TXMLModuleSession()
{}


/***************************************************************************/
/*! see IModuleSession
*/
/***************************************************************************/
unsigned long MQUALIFIER TXMLModuleSession::createObjectOfModule(unsigned long interface_id, IZUnknown** iface)
{
  unsigned long ulRetval = RET_NOERROR;

  if(iface == NULL)
  {
    ulRetval = RET_INVALID_PARAMETER;
  }
  else
  {
    switch(interface_id)
    {
      case INTERFACE_IXMLParser :
        *iface = (IXMLParser*)new TXMLParser();
        ulRetval = RET_NOERROR;
      break;

      default:
        ulRetval = RET_UNKNOWN_INTERFACE;
    }
  }
  return ulRetval;
}



