/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : XMLNodeList                                                   *
 * Package : XML_Service                                                   *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/25 10:16:21 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: XMLNodeList.cpp,v $
 *   Revision 1.2  2005/11/25 10:16:21  bhadorn
 *   pragma only supported by borland compiler
 *
 *   Revision 1.1  2005/10/28 12:13:11  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <XMLNodeList.h>
#include <XMLNode.h>

#ifdef LINUX

#else
  #pragma warn -8080
#endif

XERCES_CPP_NAMESPACE_USE
USING_NAMESPACE_Zeus

/***************************************************************************/
/*! Erstellen der XML Node List
*/
/***************************************************************************/
TXMLNodeList::TXMLNodeList(DOMNodeList* list) : TZObject()
{
  m_pNodeList = list;
}


/***************************************************************************/
/*! Zerstoeren der XMLNodeList
*/
/***************************************************************************/
TXMLNodeList::~TXMLNodeList()
{
}


/***************************************************************************/
/*! Siehe IXMLNodeList
*/
/***************************************************************************/
long MQUALIFIER TXMLNodeList::getListCount()
{
  long lCount = 0;
  if (m_pNodeList != NULL)
  {
    lCount = m_pNodeList->getLength();
  }
  else
  {
    lCount = 0;
  }

  return lCount;
}

/***************************************************************************/
/*! Siehe IXMLNodeList
*/
/***************************************************************************/
unsigned long MQUALIFIER TXMLNodeList::getNode(long index, IXMLNode** node)
{
  unsigned long ulRetval = RET_REQUEST_FAILED;
  DOMNode* pNode = NULL;
  if (m_pNodeList != NULL)
  {
    pNode = m_pNodeList->item(index);
    if (pNode != NULL)
    {
      *node = new TXMLNode(pNode);
      ulRetval = RET_NOERROR;
    }
    else
    {
      ulRetval = RET_REQUEST_FAILED;
    }
  }
  else
  {
    ulRetval = RET_REQUEST_FAILED;
  }

  return ulRetval;
}

/**************************************************************************/
/*! Memory Management
*/
/**************************************************************************/
MEMORY_MANAGER_IMPL(TXMLNodeList);
  INTERFACE_CAST(IXMLNodeList, INTERFACE_IXMLNodeList);
MEMORY_MANAGER_IMPL_END;

