/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : XMLNodeList                                                   *
 * Package : XML_Service                                                   *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:13:11 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: XMLNodeList.h,v $
 *   Revision 1.1  2005/10/28 12:13:11  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef XMLNODELIST_H
#define XMLNODELIST_H

#ifndef LINUX
  #include <mem.h>
#endif

#include <zeusbase/System/Interfaces/IXMLNodeList.hpp>
#include <zeusbase/System/ZObject.h>

#include <xercesc/dom/DOM.hpp>

XERCES_CPP_NAMESPACE_USE
BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Implementierung der Wrapperklasse fuer eine XML Node Liste
*/
/***************************************************************************/
class TXMLNodeList : public TZObject, public IXMLNodeList
{
  public:
    TXMLNodeList(DOMNodeList* list);

    //Interface IXMLNodeList
    virtual long MQUALIFIER getListCount();
    virtual unsigned long MQUALIFIER getNode(long index, IXMLNode** node);

    //Methods of IZUnknown
    MEMORY_MANAGER_DECL

  protected:
    virtual ~TXMLNodeList();

  private:
    ///Parser Instanz
    DOMNodeList* m_pNodeList;

};

END_NAMESPACE_Zeus

#endif
