/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : XMLParser                                                     *
 * Package : XML_Service                                                   *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:13:11 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: XMLParser.h,v $
 *   Revision 1.1  2005/10/28 12:13:11  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef XMLParserH
#define XMLParserH

#ifndef LINUX
  #include <mem.h>
#endif

#include <xercesc/dom/DOM.hpp>
#include <xercesc/util/XercesDefs.hpp>
#include <xercesc/parsers/XercesDOMParser.hpp>
#include <zeusbase/System/String.h>
#include <zeusbase/System/ZObject.h>
#include <zeusbase/System/Interfaces/IXMLParser.hpp>


XERCES_CPP_NAMESPACE_USE
BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Die Klasse XMLParser implementiert einen Parser zum Lesen von 
    XML Dateien und XML Streams
*/
/***************************************************************************/
class TXMLParser : public TZObject, public IXMLParser
{
  public:
    TXMLParser();

    //Methoden des IXMLParser
    virtual unsigned long MQUALIFIER loadFromFile(const IString* filename, NAMESPACE_Zeus::IXMLDocument** docu);
    virtual unsigned long MQUALIFIER parseStream(const IString* stream, NAMESPACE_Zeus::IXMLDocument** docu);

    //Methods of IZUnknown
    MEMORY_MANAGER_DECL

  protected:
    virtual ~TXMLParser();
  
  private:
    ///Parser Instanz
    XercesDOMParser* m_pParser;

};

END_NAMESPACE_Zeus

#endif
