/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : Code Module                                                   *
 * Package : Code Package                                                  *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/25 10:16:21 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: XML_Service.cpp,v $
 *   Revision 1.2  2005/11/25 10:16:21  bhadorn
 *   pragma only supported by borland compiler
 *
 *   Revision 1.1  2005/10/28 12:13:11  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <XMLParser.h>
#include <zeusbase/System/LoggerManager.h>
#include <zeusbase/System/XObjectFactory.h>
#include <zeusbase/System/LibraryManager.h>
#include <zeusdev/AbstractModuleSession.h>
#include <XMLModuleSession.h>

#ifdef LINUX

#else
  #pragma warn -8080
#endif

USING_NAMESPACE_Zeus

///////////////////////////////////////////////
// Exported Factories
MExportObjectFactory(IXMLParser, TXMLParser);
MExportObjectFactory(IModuleSession, TXMLModuleSession);
///////////////////////////////////////////////



/***************************************************************************/
/*! Start code of the module
*/
/***************************************************************************/
MODULEXPORT_PRE unsigned long MODULEXPORT_POST registerLibrary(NAMESPACE_Zeus::ISingletonManager* /*manager*/)
{
  unsigned long ulRetval = RET_NOERROR;
  try
  {
    ZLOGGER.printf(LOGMODE_INFO, "Init xerces parser...");
    XMLPlatformUtils::Initialize();
    ZLOGGER.println(LOGMODE_INFO, "..done");
  }

  catch(const XMLException &toCatch)
  {
    ulRetval = RET_INTERNAL_ERROR;
  }
  return ulRetval;
}

/***************************************************************************/
/*! End code of the module
*/
/***************************************************************************/
MODULEXPORT_PRE unsigned long MODULEXPORT_POST unregisterLibrary(NAMESPACE_Zeus::ISingletonManager* /*manager*/)
{  
  unsigned long ulRetval = RET_NOERROR;
  ZLOGGER.printf(LOGMODE_INFO, "Terminate xerces parser...");
  XMLPlatformUtils::Terminate();
  ZLOGGER.println(LOGMODE_INFO, "...done");

  return ulRetval;
}
//---------------------------------------------------------------------------
#ifdef LINUX

#else

#include <windows.h>

//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE /*hinst*/, unsigned long /*reason*/, void* /*lpReserved*/)
{
  return 1;
}
//---------------------------------------------------------------------------
#endif




