/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : GrowthCalc                                                    *
 * Package : CellModel                                                     *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:16:13 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: GrowthCalc.h,v $
 *   Revision 1.1  2005/10/28 12:16:13  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef GrowthCalcH 
#define GrowthCalcH

#include <zeusbase/System/ZObject.h>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! The grows calculator calculates the integral to clone or kill the cell
*/
/***************************************************************************/
class TGrowthCalc : public TZObject
{
  public:
    TGrowthCalc();
    
    void addData(double processtime, unsigned long jobs);
    void reset();
    bool isExceeded();
    
    void setBoundary(double value);
    void setReactionLimit(double value);
        
  protected:  
    virtual ~TGrowthCalc();
  
  private:
    ///Limit of the function
    double m_dBoundary;
    //Limit of the reaction
    double m_dReactionLimit;
    ///Last count of jobs
    unsigned long m_ulJobCount;
    ///Last difference of jobs
    long m_lJobDiff;
    ///Flag is set if the load exceeded the limit
    bool m_bExceeded; 
};

END_NAMESPACE_Zeus

#endif
