/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : ICellSurvey                                                   *
 * Package : Cell Computing                                                *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:16:13 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: ICellSurvey.hpp,v $
 *   Revision 1.1  2005/10/28 12:16:13  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ICellSurveyHPP
#define ICellSurveyHPP

#include <zeusbase/System/Interfaces/IString.hpp>
#include <zeusbase/CellModel/Interfaces/ICellKernel.hpp>
#include <zeusbase/CellModel/Interfaces/ICell.hpp>
#include <zeusbase/CellModel/Interfaces/ICommPipe.hpp>

BEGIN_NAMESPACE_Zeus

/******************************************************************************/
/*! The ICell Interface definies a diagnostic interface for cells
*/
/******************************************************************************/
class ICellSurvey : public ICellKernel
{
  public:
    virtual void MQUALIFIER registerCell(ICell* cell) = 0;
    virtual void MQUALIFIER unregisterCell(ICell* cell)=0;
    virtual void MQUALIFIER unregisterAllCells()=0;
    virtual unsigned long MQUALIFIER getInputPipe(ICommPipe** pipe)=0;
};

END_NAMESPACE_Zeus

#endif
 
 
