/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : RelayCell                                                     *
 * Package : Cell Computing                                                *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/25 09:14:42 $                                  *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: RelayCell.h,v $
 *   Revision 1.1  2005/11/25 09:14:42  bhadorn
 *   Created
 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef RelayCellH
#define RelayCellH

#include <zeusdev/AbstractCell.h>
#include <zeusbase/System/XObjectFactory.h>
#include <zeusbase/System/StringMap.hpp>

BEGIN_NAMESPACE_Zeus
 
/**************************************************************************/
/*! The cell class implements the behaviour of a basic cell
*/
/**************************************************************************/
class TRelayCell : public TAbstractCell
{
  public:
    TRelayCell(IXMLNode* node);
  
    REG_SUB_BEGIN(TRelayCell)
    REG_SUB_ADD(TRelayCell, L"TRelayCell");
    REG_SUB_END
  
    virtual void sendLifeSignal();
    
  protected:
    virtual ~TRelayCell();
  
  private:
    struct RRelayEntry
    {
      ///Name of the Forwarding cell
      TString strCellName;
      ///Name of the Forwarding pipe
      TString strPipeName;
      
      RRelayEntry()
      {}
      
      RRelayEntry(TString cellname, TString pipename)
      {
        strCellName = cellname;
        strPipeName = pipename;
      }
    
      bool operator==(const RRelayEntry& inpar)
      {  
        return (this->strCellName == inpar.strCellName &&
                this->strPipeName == inpar.strPipeName);
      }
    
    };
    ///Map with names
    TStringMap<RRelayEntry> m_mapNames;
   
};

END_NAMESPACE_Zeus

#endif
