/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : InterfaceID                                                   *
 * Package : System                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/12/14 08:55:38 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: InterfaceID.hpp,v $
 *   Revision 1.2  2005/12/14 08:55:38  bhadorn
 *   no message
 *
 *   Revision 1.1  2005/11/10 10:34:24  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef InterfaceIDHPP
#define InterfaceIDHPP

#include <stddef.h>


#define INTERFACE_IZUnknown                      0
#define INTERFACE_ISerializable                  1
#define INTERFACE_IRunnable                      2
#define INTERFACE_IXObject                       3
#define INTERFACE_IXLoaderObject                 4
#define INTERFACE_IXObjectFactory                5
#define INTERFACE_ICellKernel                    6
#define INTERFACE_ICommPipe                      7
#define INTERFACE_ILocalPipeRegistry             8
#define INTERFACE_IPropertyAccess                10
#define INTERFACE_ISubject                       11
#define INTERFACE_IObserver                      12
#define INTERFACE_IZObjectFactory                13
#define INTERFACE_IInputStream                   14
#define INTERFACE_IOutputStream                  15
#define INTERFACE_INaming                        16
#define INTERFACE_IRemoteObject                  17
#define INTERFACE_IRemoteMethodCall              18
#define INTERFACE_IZVariant                      19
#define INTERFACE_IRemoteObjectStub              20
#define INTERFACE_ISimpleCommand                 21

 
#define INTERFACE_IMessage                       30 
#define INTERFACE_IAttributeMessage              31 
#define INTERFACE_IXMLMessage                    32
#define INTERFACE_IBinaryMessage                 33
#define INTERFACE_ISystemMessage                 34
#define INTERFACE_IObjectMessage                 35
#define INTERFACE_IListMessage                   36
#define INTERFACE_ITextMessage                   37

 
#define INTERFACE_IModule                        50 
#define INTERFACE_IModuleManager                 51 
#define INTERFACE_IZeusAPI                       52
#define INTERFACE_IModuleSession                 53

#define INTERFACE_ICellComm                      70

#define INTERFACE_IGAIndividual                  80
#define INTERFACE_IGAChromosone                  81
#define INTERFACE_IGAPopulation                  82
#define INTERFACE_IGALongGene                    85

#define INTERFACE_IXMLParser                     100 
#define INTERFACE_IXMLNodeList                   101
#define INTERFACE_IXMLNode                       102 
#define INTERFACE_IXMLDocument                   103 

#define INTERFACE_ICellRegistry                  200
#define INTERFACE_ICellSurvey                    201
#define INTERFACE_ICell                          202

#define INTERFACE_ILogger                        300

#define INTERFACE_ICellMonitor                   400 

//Broadcast types
#define BC_TEST                                  0

//Error messages
#define RET_NOERROR                              0
#define RET_UNKNOWN_INTERFACE                    1
#define RET_INVALID_PARAMETER                    2
#define RET_REQUEST_FAILED                       3
#define RET_INTERNAL_ERROR                       4
#define RET_METHOD_NOT_IMPL                      5
#define RET_REMOTECALL_ERROR                     6
#define RET_INVALID_DATA                         7
#define RET_UNREGISTERED_CLASS                   8
#define RET_NOT_READY                            9
#define RET_ACCESS_DENIED                       10
#define RET_REMOTEPROTOCOL_ERROR                11
#define RET_NETWORK_ERROR                       12



#define RET_OK                                  20
#define RET_CANCEL                              21
#define RET_YES                                 22
#define RET_NO                                  23



//Custom Interface ID should be defined with a value
// Greater than CUSTOM_SECTION
#define CUSTOM_SECTION                        50000
#include <zeusbase/Config/CustomInterfaceID.hpp>
#endif
