/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : Object                                                   *
 * Package : System                                                  *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/25 09:31:16 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: PlatformDefines.hpp,v $
 *   Revision 1.2  2005/11/25 09:31:16  bhadorn
 *   defines for borland C++ Builder
 *
 *   Revision 1.1  2005/11/10 10:34:24  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef PlatformDefinesHPP
#define PlatformDefinesHPP


///Version of the zeus framework
#define ZEUS_VERSION            "0.2.3"


//Framework bindings 

///Use QT bindings
//#define USE_QT_BINDINGS 

#ifdef __BORLANDC__
//Use bindings for borland framework
  #define USE_BCB_BINDINGS
#endif

//Use bindings for migrossoft visual studio
//#define USE_VC_BINDINGS

//Use bindings standard library
#define USE_STL_BINDINGS 

#ifdef LINUX
  #define MQUALIFIER
  #define MODULEXPORT_POST
  #define MODULIMPORT_POST
  #define MODULEXPORT_PRE       extern "C"
#else
  #define MQUALIFIER            __stdcall
  #define MODULEXPORT_POST      __declspec(dllexport) MQUALIFIER
  #define MODULIMPORT_POST      __declspec(dllimport) MQUALIFIER
  #define MODULEXPORT_PRE       extern "C"
#endif

//Namespace of Zeus
#define NAMESPACE_Zeus          Zeus

#define BEGIN_NAMESPACE_Zeus    namespace NAMESPACE_Zeus {
#define END_NAMESPACE_Zeus      }
#define USING_NAMESPACE_Zeus    using namespace NAMESPACE_Zeus;

#endif

