/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : ZeusAPI                                                       *
 * Package : Main Interface of the framework                               *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:28:57 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: ZeusAPI.h,v $
 *   Revision 1.1  2005/11/10 10:28:57  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 

#ifndef ZeusAPIH
#define ZeusAPIH
 
#include <zeusbase/MOM/Interfaces/IZeusAPI.hpp>
#include <zeusbase/MOM/Module.h>
#include <zeusbase/System/ZObject.h>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Implementation of the Zeus framework API
*/
/***************************************************************************/
class TZeusAPI : public TZObject, public IZeusAPI
{
  public:
    TZeusAPI(TModule* module);
    virtual ~TZeusAPI();
  
    //Methods of IZeusAPI
    virtual unsigned long MQUALIFIER getXObject(IString* path, IXObject** obj);
    virtual unsigned long MQUALIFIER createObjectOfModule(IString* module_name, unsigned long interface_id, IZUnknown** iface);
    
    //Methods of IZUnknown
    MEMORY_MANAGER_DECL
  
  private:
    ///Cross Reference of the parent module
    TModule* m_pModule;

};

END_NAMESPACE_Zeus

#endif
