/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : GAIndividual                                                  *
 * Package : Genetic                                                       *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:26:39 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: GAIndividual.h,v $
 *   Revision 1.1  2005/11/10 10:26:39  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GAIndividualH
#define GAIndividualH

#include <zeusbase/Math/Interfaces/IGAIndividual.hpp>
#include <zeusbase/System/ZObject.h>
#include <zeusbase/System/ArrayList.hpp>

BEGIN_NAMESPACE_Zeus

/**************************************************************************/
/*! Abstract implementation of an individual
*/
/**************************************************************************/
class TGAIndividual : public TZObject, public IGAIndividual
{
  public:
    TGAIndividual();
    
    //Methods of IGAIndividual
    virtual double MQUALIFIER getFitness()=0;
    virtual long MQUALIFIER getChromosoneCount();
    virtual unsigned long MQUALIFIER getChromosone(long index, IGAChromosone** chromosone);
    virtual unsigned long MQUALIFIER addChromosone(IGAChromosone* chromosone);
    virtual void MQUALIFIER createChromosones()=0;
    
    //Methods of IZUnknown
    MEMORY_MANAGER_DECL
    
  protected:
    virtual ~TGAIndividual();
  
    ///List of Chromosones
    TArrayList<IGAChromosone*> m_lstChromosones;
};

END_NAMESPACE_Zeus
 
#endif
