/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : IGAGene                                                       *
 * Package : Genetic                                                       *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:27:22 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: IGAGene.hpp,v $
 *   Revision 1.1  2005/11/10 10:27:22  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef IGAGeneHPP 
#define IGAGeneHPP 

#include <zeusbase/System/Interfaces/IZUnknown.hpp>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! This interface represents a gene of a chromosone
*/
/***************************************************************************/
class IGAGene : public IZUnknown
{
  public:
    /***********************************************************************/
    /*! Returns the InterfaceID of the specific gene implemenation
        \return InterfaceID
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER getInterfacID()=0;
};

/***************************************************************************/
/*! This interface represents a gene of a chromosone containing a long value
*/
/***************************************************************************/
class IGALongGene : public IGAGene
{
  public:
    /***********************************************************************/
    /*! returns the long - value of the gene
    */
    /***********************************************************************/
    virtual long MQUALIFIER getLongValue()=0;
};

END_NAMESPACE_Zeus

#endif
 
