/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : IBinaryMessag                                                 *
 * Package : Messaging                                                     *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:57:46 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: IBinaryMessage.hpp,v $
 *   Revision 1.1  2005/11/10 10:57:46  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 

#ifndef IBinaryMessageHPP
#define IBinaryMessageHPP


#include <zeusbase/Messaging/Interfaces/IMessage.hpp>
#include <zeusbase/System/Interfaces/IByteArray.hpp>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Marker Interface for simple XML message objects.
*/
/***************************************************************************/
class IBinaryMessage : public IMessage
{
  public:
    /***********************************************************************/
    /*! Gets the binary data
        \param data : Return parameter of the binary data
        \retval RET_NOERROR : Data returned
        \retval RET_INVALID_PARAMETER : Invalid parameter received
        \retval RET_REQUEST_FAILED : No data to return
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER getData(IByteArray* data) const=0;
    
    /***********************************************************************/
    /*! Gets the type of data 
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER getDataType() const=0;
    
    /***********************************************************************/
    /*! Sets new binary data
        \param data : Data to set
        \retval RET_NOERROR : Data set (also empty data)
        \retval RET_INVALID_PARAMETER : Invalid parameter received
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER setData(IByteArray* data)=0;
    
    /***********************************************************************/
    /*! Sets the type of data 
    */
    /***********************************************************************/
    virtual void MQUALIFIER setDataType(unsigned long type)=0;
};

END_NAMESPACE_Zeus

#endif 
