/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : IMessageObject                                                *
 * Package : System                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:57:46 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: ISystemMessage.hpp,v $
 *   Revision 1.1  2005/11/10 10:57:46  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 

#ifndef ISystemMessageObjectHPP
#define ISystemMessageObjectHPP

#define MSG_NOP                                                0
#define MSG_FLUSH                                              2
#define MSG_PING_REQUEST                                       100 
#define MSG_PING_RESPONSE                                      101 

#include <zeusbase/Messaging/Interfaces/IMessage.hpp>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Marker Interface for system message object
*/
/***************************************************************************/
class ISystemMessage : public IMessage
{
  public:
    
    /***********************************************************************/
    /*! returns the type of the message
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER getMessageType() const=0;
    
    /***********************************************************************/
    /*! sets a new Message type
    */
    /***********************************************************************/
    virtual void MQUALIFIER setMessageType(unsigned long type)=0;

};

END_NAMESPACE_Zeus

#endif 
 
