/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : IXMLMessage                                                   *
 * Package : Messaging                                                     *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:57:46 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: IXMLMessage.hpp,v $
 *   Revision 1.1  2005/11/10 10:57:46  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 

#ifndef IXMLMessageHPP
#define IXMLMessageHPP


#include <zeusbase/System/Interfaces/IXMLNode.hpp>
#include <zeusbase/Messaging/Interfaces/IMessage.hpp>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Marker Interface for simple XML message objects.
*/
/***************************************************************************/
class IXMLMessage : public IMessage
{
  public:
    /***********************************************************************/
    /*! Returns the reference of the XML Data Node.
        \param node : Return parameter
        \retval RET_NOERROR : Node successfully returned
        \retval RET_REQUEST_FAILED : Could not return node
        \retval RET_INVALID_PARAMETER : Invalid parameter received.
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER getDataNode(IXMLNode** node)=0;
};

END_NAMESPACE_Zeus

#endif 
