/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : IRemoteObjectStub                                             *
 * Package : Remote                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:39:54 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: IRemoteObjectStub.hpp,v $
 *   Revision 1.1  2005/11/10 10:39:54  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef IRemoteObjectStubHPP
#define IRemoteObjectStubHPP

#include <zeusbase/Remote/Interfaces/IRemoteObject.hpp>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! The remote object stub is used for connecting to the remote object
*/
/***************************************************************************/
class IRemoteObjectStub : public IRemoteObject
{
  public:
    
    /***********************************************************************/
    /*! Sets the classname of the remote object
        \param name : Return parameter
        \retval RET_NOERROR : Name returned
        \retval RET_INVALID_PARAMETER : Invalid parameter received;
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER setClassName(const IString* name)=0;
    
    /***********************************************************************/
    /*! Set the name of the codemodule for the remote object
        \param name : Return parameter
        \retval RET_NOERROR : Name returned
        \retval RET_INVALID_PARAMETER : Invalid parameter received;
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER setCodeModuleName(const IString* name)=0;
    
    /***********************************************************************/
    /*! Connects to the remote object
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER connect(const IString* address, unsigned long port)=0;
};

END_NAMESPACE_Zeus

#endif
 
