/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : RemoteDefines                                                 *
 * Package : Remote                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/16 12:00:21 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: RemoteDefines.hpp,v $
 *   Revision 1.1  2005/11/16 12:00:21  bhadorn
 *   Defines for remote objects
 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef RemoteDefinesH
#define RemoteDefinesH
 

/**************************************************************************/
/*! Defines the method to quit the connection
*/
/**************************************************************************/
#define REMOTE_QUIT                     "rem_quit"

/**************************************************************************/
/*! Returns the parameter name for a list count. This is used if you want
    to submit a list of data. Therefore you add a parameter containing the
    count of the list, followed by elements. Add the elements using the 
    macro RPARAM_LIST_ITEM.
    \param __name : Name of the list parameter
*/
/**************************************************************************/
#define RPARAM_LIST_COUNT(__name)       TString(__name) + TString(L"___count")

/**************************************************************************/
/*! Returns a parameter name for an item. How to use see RPARAM_LIST_COUNT
    description.
    \param __name : Name of the list parameter
    \param __index : Index of the item
*/
/**************************************************************************/
#define RPARAM_LIST_ITEM(__name, __index)    TString(__name) + TString(L"___") + (long)__index

#endif
