/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : ByteArrayInputStream                                          *
 * Package : System                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/16 11:27:05 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: ByteArrayInputStream.h,v $
 *   Revision 1.2  2005/11/16 11:27:05  bhadorn
 *   Changed parameter of constructor to [const].
 *
 *   Revision 1.1  2005/11/10 10:18:25  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef ByteArrayInputStreamH
#define ByteArrayInputStreamH

#include <zeusbase/System/Interfaces/IInputStream.hpp>
#include <zeusbase/System/ZObject.h>
#include <stdio.h>
#include <sstream>
#include <iostream>

BEGIN_NAMESPACE_Zeus 

/***************************************************************************/
/*! This class is used read out of a byte array
*/
/***************************************************************************/
class TByteArrayInputStream : public TZObject, public IInputStream
{
  public:
    TByteArrayInputStream();
    TByteArrayInputStream(const IByteArray* array);

    virtual bool MQUALIFIER available() const;
    virtual bool MQUALIFIER isEmpty() const;
    virtual unsigned long MQUALIFIER read(char* buffer, long buffer_size, long* valid_size) const;
    virtual double MQUALIFIER readDouble() const;
    virtual long MQUALIFIER readLong() const;
    virtual char MQUALIFIER readByte() const;
    virtual bool MQUALIFIER readBool() const;
    virtual unsigned long MQUALIFIER readArray(IByteArray* data) const;
    virtual unsigned long MQUALIFIER readString(IString* data) const;
    virtual void MQUALIFIER close();
  
    //Methods of IZUnknown
    MEMORY_MANAGER_DECL
    
  protected:
    virtual ~TByteArrayInputStream();
    
  private:
    ///Stream class
    std::iostream* m_pStream;
    ///Memory buffer
    std::streambuf* m_pBuffer;
};


END_NAMESPACE_Zeus

#endif
