/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : Directory                                                     *
 * Package : System                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:18:25 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: Directory.h,v $
 *   Revision 1.1  2005/11/10 10:18:25  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef DirectoryH
#define DirectoryH

#include <zeusbase/System/Interfaces/IZUnknown.hpp>
#include <zeusbase/System/String.h>
#include <zeusbase/System/ZObject.h>


#ifdef LINUX
  #define PATH_DELIMITER        L'/'
#else
  #define PATH_DELIMITER        L'\\'
#endif

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! The directory class implements methods to access the system directory
*/
/***************************************************************************/
class TDirectory : public TZObject
{
  public:
    TDirectory(TString abs_name);
    virtual ~TDirectory();
    
    TString getAbsoluteName();
    
    static unsigned long getCurrentDirectory(TDirectory** dir);
        
  private:
    ///Absolute name
    TString m_strAbsName;
    
    static TString completePath(TString path);
   
};


END_NAMESPACE_Zeus

#endif
