/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : IObserver                                                     *
 * Package : system                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:22:53 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: IObserver.hpp,v $
 *   Revision 1.1  2005/11/10 10:22:53  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IObserverHPP
#define IObserverHPP

#include <zeusbase/System/Interfaces/IZUnknown.hpp>

BEGIN_NAMESPACE_Zeus

/*****************************************************************************/
/*! Der ISTObserver dient als Observerschnittstelle welche standard Methoden
    eines Observers definiert.
*/
/*****************************************************************************/
class IObserver : public IZUnknown
{
  public:

    /*************************************************************************/
    /*! Diese Methode gibt den Observer frei. Ein Enable kann dadurch erfolgen.
        Speziell beim Anmelden wird diese Methode aufgerufen
    */
    /*************************************************************************/
    virtual void MQUALIFIER unlockObserver()=0;


    /*************************************************************************/
    /*! Diese Methode sperrt den Observer. Ein Disable kann dadurch erfolgen.
        Speziell beim Abmelden wird diese Methode aufgerufen
    */
    /*************************************************************************/
    virtual void MQUALIFIER lockObserver()=0;

    /*************************************************************************/
    /*! Den Parent loeschen. Diese Methode sollte nur vom Besitzer des
        Observer aufgerufen werden.
    */
    /*************************************************************************/
    virtual void MQUALIFIER clearParent()=0;

};

END_NAMESPACE_Zeus

#endif


