/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : IObserver                                                     *
 * Package : system                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:22:53 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: ISubject.hpp,v $
 *   Revision 1.1  2005/11/10 10:22:53  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ISubjectHPP
#define ISubjectHPP

#include <zeusbase/System/Interfaces/IObserver.hpp>

BEGIN_NAMESPACE_Zeus

/*****************************************************************************/
/*! Definiert im Subject-Observer-Pattern das Subject. Dem Subject knnen
    mehrere Observer registriert und dann wieder entfernt werden.
*/
/*****************************************************************************/
class ISubject : public IZUnknown
{
  public:
    /*************************************************************************/
    /*! Ein Observer hinzufgen
        \param obs : Referenz auf den Observer
        \retval RET_NOERROR: Fehlerfreies hinzufgen des Observers
        \retval RET_REQUEST_FAILED : Observer kann nicht hinzugefgt werden
        \retval RET_INVALID_PARAMETER: Fehlerhafter Parameter
    */
    /*************************************************************************/
    virtual unsigned long MQUALIFIER attach(IObserver* obs)=0;

    /*************************************************************************/
    /*! Ein Observer entfernen
        \param obs : Referenz auf den Observer
        \retval RET_NOERROR: Fehlerfreies entfernen des Observers
        \retval RET_REQUEST_FAILED : Observer kann nicht entfernt werden
        \retval RET_INVALID_PARAMETER: Fehlerhafter Parameter
    */
    /*************************************************************************/
    virtual unsigned long MQUALIFIER detach(IObserver* obs)=0;

};


END_NAMESPACE_Zeus

#endif