
#ifndef IXMLNodeListHPP
#define IXMLNodeListHPP

#include <zeusbase/System/Interfaces/IZUnknown.hpp>
#include <zeusbase/System/Interfaces/IXMLNode.hpp>

BEGIN_NAMESPACE_Zeus

class IXMLNode;

/******************************************************************************/
/*! Das IXMLNodeList definiert eine Schnittstelle zu der XMLNodeList eines
    DOM Trees. Hier sind alle Nodes eines Parentnodes enthalten
*/
/******************************************************************************/
class IXMLNodeList : public IZUnknown
{
  public :
    /**************************************************************************/
    /*! Mit dieser Funktion laest es sich bestimmen wieviele SubNodes im der
        Liste vorhanden sind.
        \return Groesse der Liste
    */
    /**************************************************************************/
    virtual long MQUALIFIER getListCount() = 0;

    /**************************************************************************/
    /*! Diese Funktion gibt einen indexierten SubNode in der Liste zurck.
        \param  index : Wahl des Nodes
        \param node : Rckgabeparameter
        \retval RET_NOERROR : Fehlerfreie Rckgabe
        \retval RET_REQUEST_FAILED : Der Knoten kann nicht zurckgegeben werden
        \retval RET_INVALID_PARAMETER: Fehlerhafter Rckgabeparameter
    */
    /**************************************************************************/
    virtual unsigned long MQUALIFIER getNode(long index, IXMLNode** node) = 0;
};

END_NAMESPACE_Zeus

#endif
