/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 ***************************************************************************
 * Projekt : Zeus                                                          *
 * Module  : IZUnknown                                                      *
 * Package : System                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:22:53 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: IZUnknown.hpp,v $
 *   Revision 1.1  2005/11/10 10:22:53  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IZUnknownHPP
#define IZUnknownHPP

#include <zeusbase/Config/PlatformDefines.hpp>
#include <zeusbase/Config/InterfaceID.hpp>
#include <zeusbase/System/Interfaces/IZUnknownImplHelper.hpp>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Das IZUnknown dient als Basisklasse der Interfaces. Es
    definiert Methoden der C++ Speicherverwaltung
*/
/***************************************************************************/
class IZUnknown
{
  public:

    /***********************************************************************/
    /*! Mit dieser Methode kann auf ein Interface ein casting durchgefuehrt
        werden
        \param interface_id : ID des zu castendem Interface
        \param iface : Rueckgabe des gecastetem Interface
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER askForInterface(long interface_id, IZUnknown** iface)=0;

    /***********************************************************************/
    /*! Durch diese Methode kann eine Referenz alloziert werden.
        \retval RET_NOERROR : Reference allocated
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER addRef()=0;

    /***********************************************************************/
    /*! Durch diese Methode kann eine Referenz freigegeben werden.
        \retval RET_NOERROR : Reference released
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER release()=0;
};

END_NAMESPACE_Zeus

#endif
