/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : Code Module                                                   *
 * Package : Code Package                                                  *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:20:17 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: Logger.h,v $
 *   Revision 1.1  2005/11/10 10:20:17  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef LOGGER_H
#define LOGGER_H

#include <zeusbase/System/Interfaces/IZUnknown.hpp>
#include <zeusbase/System/Interfaces/ILogger.hpp>
#include <zeusbase/System/String.h>
#include <zeusbase/System/ObjectPtr.hpp>


BEGIN_NAMESPACE_Zeus

#define LOGMODE_DEBUG          0
#define LOGMODE_INFO           1 
#define LOGMODE_WARN           2 
#define LOGMODE_ERROR          3 
#define LOGMODE_FATAL          4

/***************************************************************************/
/*! This class is responsible for logging and debug output
*/
/***************************************************************************/
class TLogger : public TZObjectPtr<ILogger>
{
  public:
    TLogger(ILogger* obj);
    virtual ~TLogger();

    //Methods to print a debug out
    void print(unsigned long mode, char* txt,...);
    void println(unsigned long mode, char* txt,...);
    void printf(unsigned long mode, char* txt,...);
    void printfln(unsigned long mode, char* txt,...);

    void out(char* txt,...);
    
    //Methods to control offset
    void resetOffset();
    void setOffset(long value);
    void indent();
    void unindent();

  private:
    ///Offset of Text indention
    long m_lOffset;
};

END_NAMESPACE_Zeus

#endif
