/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : LoggerManager                                                 *
 * Package : help_impl                                                     *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:20:44 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: LoggerManager.h,v $
 *   Revision 1.1  2005/11/10 10:20:44  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef LoggerManagerH 
#define LoggerManagerH 

#include <zeusbase/System/Logger.h>
#include <zeusbase/System/Interfaces/ILogger.hpp>

BEGIN_NAMESPACE_Zeus

#define ZLOGGER                TLoggerManager::getRoot()

/**************************************************************************/
/*! This singleton object contains the root logger object.
*/
/**************************************************************************/
class TLoggerManager :  public TZObject
{
  public:
    static TLoggerManager& getInstance();
    static TLogger& getRoot();
    
    void setLogger(ILogger* logger);
    unsigned long initLogger(TString modulename);
    void uninit();
    
  private:
    TLoggerManager();
    virtual ~TLoggerManager();
    
    ///Static object
    static TLoggerManager m_LoggerManager;
    ///root logger instance
    TLogger m_RootLogger;
};

END_NAMESPACE_Zeus

#endif
