/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : NetworkInterface                                              *
 * Package : System                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/16 11:53:28 $
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: NetworkInterface.h,v $
 *   Revision 1.1  2005/11/16 11:53:28  bhadorn
 *   Created network interface class
 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef NetworkInterfaceH
#define NetworkInterfaceH

#include <zeusbase/System/ZObject.h>

BEGIN_NAMESPACE_Zeus

#define NET_Local        L"lo"
#define NET_Iface_1      L"eth0"
#define NET_Iface_2      L"eth1"

/****************************************************************************/
/*! This class wrapps a network device (interface). Use this to get the 
    ip address of the device.
*/
/****************************************************************************/
class TNetworkInterface : public TZObject
{
  public:
    static unsigned long getInterfaceByName(TString name, TNetworkInterface** iface);
    
    TString getAddress();
    
  protected:
    TNetworkInterface(TString name, TString address);
    virtual ~TNetworkInterface();
    
  private:
    ///IP Address of network
    TString m_strAddress;
  
};

END_NAMESPACE_Zeus

#endif
