/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Cell Registry                                                 *
 * Module  : CCTPRequest                                                    *
 * Package : Protocols                                                     *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/16 11:35:17 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: CCTPRequest.h,v $
 *   Revision 1.2  2005/11/16 11:35:17  bhadorn
 *   In parameter are [const]
 *
 *   Revision 1.1  2005/11/10 10:24:34  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 

 
 
#ifndef CCTPRequestH
#define CCTPRequestH

#include <zeusbase/System/Interfaces/IZUnknown.hpp>
#include <zeusbase/System/Protocols/CCTPDefines.hpp>
#include <zeusbase/System/ZObject.h>
#include <zeusbase/System/String.h>
#include <zeusbase/System/ByteArray.hpp>
#include <zeusbase/System/Queue.hpp>

BEGIN_NAMESPACE_Zeus


/***************************************************************************/
/*! This class wrapps a HTTP Request object
*/
/***************************************************************************/
class TCCTPRequest : public TZObject
{
  public:
    TCCTPRequest();
    virtual ~TCCTPRequest();

    const TByteArray& getData() const;
    unsigned long getMethod() const;
    unsigned long getObjectType() const;
        
    void setData(const TByteArray& data);
    void setMethod(unsigned long method);
    void setObjectType(unsigned long obj);
    
    unsigned long parse(const TByteArray& in);
    unsigned long toStream(TByteArray* array) const;
  
  private:
    ///Version number
    unsigned long m_ulVersion;
    ///Method
    unsigned long m_ulMethod;
    ///Method
    unsigned long m_ulObjectType;
    ///Data Body
    TByteArray m_aData;
};

END_NAMESPACE_Zeus

#endif
