/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Cell Registry                                                 *
 * Module  : CCTPResponse                                                   *
 * Package : Protocols                                                     *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/16 11:35:17 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: CCTPResponse.h,v $
 *   Revision 1.2  2005/11/16 11:35:17  bhadorn
 *   In parameter are [const]
 *
 *   Revision 1.1  2005/11/10 10:24:34  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/  

#ifndef CCTPResponseH 
#define CCTPResponseH
 
#include <zeusbase/System/Interfaces/IZUnknown.hpp>
#include <zeusbase/System/Protocols/CCTPDefines.hpp>
#include <zeusbase/System/ZObject.h>
#include <zeusbase/System/String.h>
#include <zeusbase/System/ByteArray.hpp>
#include <zeusbase/System/Queue.hpp>


BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! This class wrapps a CCTP Response object
*/
/***************************************************************************/
class TCCTPResponse : public TZObject
{
  public:
    TCCTPResponse();
    virtual ~TCCTPResponse();
    
    const TByteArray& getData() const;
    unsigned long getState() const;
    
    unsigned long parse(const TByteArray& in);
    unsigned long toStream(IByteArray* array) const;
    void setData(const TByteArray& data);
    void setState(unsigned long state);
    
  
  private:
    ///Protocol number
    unsigned long m_ulVersion;
    ///Status of Response
    unsigned long m_ulState;
    ///Databody
    TByteArray m_aData;
};

END_NAMESPACE_Zeus

#endif
