/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Cell Registry                                                 *
 * Module  : HTTPDefines                                                    *
 * Package : Protocols                                                     *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:24:34 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: HTTPDefines.hpp,v $
 *   Revision 1.1  2005/11/10 10:24:34  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 
#ifndef HTTPDefinesHPP
#define HTTPDefinesHPP

  #define HTTP_STATUS_OK                              200
  #define HTTP_STATUS_BADREQUEST                      400
  #define HTTP_STATUS_METHODFAILED                    480
  #define HTTP_STATUS_INTERNALSERVERERROR             500
  
  #define HTTP_METHOD_UNKNOWN                         2 
  #define HTTP_METHOD_POST                            1
//  #define HTTP_METHOD_GET                             1

  //Used internally by the Scanner
  #define HTTP_TOKEN_DATA                             0
  #define HTTP_TOKEN_NEWLINE                          1
  #define HTTP_TOKEN_SPACE                            2

  #define HTTPSCAN_STATE_HEADER                       0
  #define HTTPSCAN_STATE_BODY                         1
  #define HTTPSCAN_STATE_ERROR                        2
  
  
  #define HTTPPARSE_STATE_PROTOCOL                    0
  #define HTTPPARSE_STATE_STATUSCODE                  2 
  #define HTTPPARSE_STATE_STATUSTEXT                  3
  #define HTTPPARSE_STATE_HEADER_START                4
  #define HTTPPARSE_STATE_HEADER                      5
  #define HTTPPARSE_STATE_BODY                        6
  #define HTTPPARSE_STATE_METHOD                      7
  #define HTTPPARSE_STATE_RESSOURCE                   8
  #define HTTPPARSE_STATE_ERROR                       10 
  
#endif
