/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : ServerSocket                                                  *
 * Package : System                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/16 11:29:16 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: ServerSocket.h,v $
 *   Revision 1.2  2005/11/16 11:29:16  bhadorn
 *   Added dynamic binding for servers. The port addess will be choosen dynamically
 *
 *   Revision 1.1  2005/11/10 10:20:44  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 

#ifndef ServerSocketH
#define ServerSocketH

#include "zeusbase/System/Socket.h"

BEGIN_NAMESPACE_Zeus
/**************************************************************************/
/*! The Server socket class implements all platform dependend calls to the
    network interface
*/
/**************************************************************************/
class TServerSocket : public TSocket
{
  public:
    TServerSocket(TString addr, unsigned long port);
    virtual ~TServerSocket();
    
    virtual unsigned long bind(bool dynamic_binding = false);
    virtual unsigned long accept(TSocket** client);
    virtual unsigned long acceptTO(TSocket** client, double timeout);
    virtual void setReUsable();
    
    //Methods of TSocket
    virtual unsigned long connect() { return RET_REQUEST_FAILED; }
    
  private:
    ///Count of max connected clients
    long m_lMaxClients;
    ///Flag for reusable 
    bool m_bResusable;
    
    unsigned long acceptInternal(TSocket** client, double timeout);
    unsigned long bindInternal();
    
   
};

END_NAMESPACE_Zeus

#endif 
