/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : StdLogger                                                     *
 * Package : System                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:22:07 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: StdLogger.h,v $
 *   Revision 1.1  2005/11/10 10:22:07  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef StdLoggerH
#define StdLoggerH

#include <zeusbase/System/Interfaces/ILogger.hpp>
#include <zeusbase/System/ZObject.h>
#include <zeusbase/System/String.h>


BEGIN_NAMESPACE_Zeus
/***************************************************************************/
/*! Implements the loggin to the standard out.
*/
/***************************************************************************/
class TStdLogger : public TZObject, public ILogger
{
  public:
    TStdLogger(const TString& name = L"");

    //Methods of ILogger
    virtual unsigned long MQUALIFIER getLogger(IString* name, ILogger** logger);
    virtual unsigned long MQUALIFIER printDebug(IString* message);
    virtual unsigned long MQUALIFIER printError(IString* message);
    virtual unsigned long MQUALIFIER printFatal(IString* message);
    virtual unsigned long MQUALIFIER printInfo(IString* message);
    virtual unsigned long MQUALIFIER printWarn(IString* message);
    virtual bool MQUALIFIER isDebugEnabled();
    virtual bool MQUALIFIER isErrorEnabled();
    virtual bool MQUALIFIER isFatalEnabled();
    virtual bool MQUALIFIER isInfoEnabled();
    virtual bool MQUALIFIER isWarnEnabled();
    virtual unsigned long MQUALIFIER loadConfiguration(IString* file);
    virtual unsigned long MQUALIFIER loadProperties(IPropertyAccess* prop);

    //Methods of IZUnknown
    MEMORY_MANAGER_DECL

  protected:
    virtual ~TStdLogger();
    
  private:
    ///Name of the logger
    TString m_strName;
    ///Flag if Debug is enabled
    bool m_bDebug;
    ///Flag if Info is enabled
    bool m_bInfo;
    ///Flag if Warning is enabled
    bool m_bWarn;
    ///Flag if Error is enabled
    bool m_bError;
    ///Flag if Fatal is enabled
    bool m_bFatal;

    void write(TString& txt);
};

END_NAMESPACE_Zeus
#endif
