/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : StreamScanner                                                 *
 * Package : System                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:22:07 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: StreamScanner.h,v $
 *   Revision 1.1  2005/11/10 10:22:07  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef StreamScannerH 
#define StreamScannerH

#include <zeusbase/System/Interfaces/IInputStream.hpp>


BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! The stream scanner scanns the attribute of a streamable object and
    returns its agruments (attribute and value).
    Its limited to scann only primitive values such as string, long, double
    etc. Composed attribute (other streamable objects) wont be handled.
*/
/***************************************************************************/
class TStreamScanner 
{
  public:
    TStreamScanner();
    virtual ~TStreamScanner();
    
    unsigned long scan(IInputStream* stream);
    
  private:
   /*************************************************************************/
   /*! Header structure of the stream
   */
   /*************************************************************************/
   struct RObjectHeader
   {
     unsigned short usObjectID;
     unsigned short usObjectType;
     unsigned long* ulAttrCount;
     unsigned long* ulBodyLen;
   };
   
   struct RObjectAttribute
   {
     unsigned short usAttributeID;
     unsigned short usAttributeLen;
   };
   
   ///Header of the scanned object
   RObjectHeader m_Header;
};

END_NAMESPACE_Zeus

#endif
