/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : XMLObject                                                     *
 * Package : System                                                        *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:21:24 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: XRootObject.h,v $
 *   Revision 1.1  2005/11/10 10:21:24  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef XRootObjectH
#define XRootObjectH 

#include <zeusbase/System/XObject.h> 
#include <zeusbase/System/Interfaces/IXMLDocument.hpp>


BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! This is the base class for all XML based objects.
*/
/***************************************************************************/
class TXRootObject : public TXObject
{
  public:
    TXRootObject(IXMLNode* node, NAMESPACE_Zeus::IXMLDocument* docu);
    TXRootObject(IXMLNode* node);
    
    unsigned long save();
    unsigned long saveAs(TString filename);
    
    
    //Method of XObject
    virtual TString getXMLStream() const;
    
    
  protected:   
    ///XML Parser
    IXMLDocument* m_pDocument;
    
    TXRootObject();
    virtual ~TXRootObject();
    
  private:
  
}; 

END_NAMESPACE_Zeus
#endif
 
