/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : Object                                                   *
 * Package : Application                                                  *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:21:24 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: ZObject.h,v $
 *   Revision 1.1  2005/11/10 10:21:24  bhadorn
 *   Created
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ZObjectH
#define ZObjectH 

#include <zeusbase/System/Interfaces/IZUnknown.hpp> 
#include <zeusbase/Config/PlatformDefines.hpp>
#include <zeusbase/System/Platforms/Transcoder.hpp>
#include <zeusbase/System/String.h>

#ifdef LINUX

#else
  #include <windows.h>
#endif


BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Die Klasse Object ist ist die Basisklasse des Frameworks
*/
/***************************************************************************/
class TZObject : protected IZUnknown
{
  public:
    TZObject();
    TZObject(TString name);
        
    virtual unsigned long getHash() const;
    virtual TString getObjName() const;
    virtual void setObjName(const TString& name);
    
    //Methoden des IZUnknown
    virtual unsigned long MQUALIFIER askForInterface(long interface_id, IZUnknown** iface);
    virtual unsigned long MQUALIFIER addRef();
    virtual unsigned long MQUALIFIER release();

  protected:
    virtual ~TZObject();
    unsigned long getRefCounter() const;
    
    unsigned long m_ulID;
    
  private:
    ///Reference counter
    unsigned long m_ulRefCounter;
    ///Name of the object
    TString m_strName;
}; 

END_NAMESPACE_Zeus
#endif
