//---------------------------------------------------------------------------
/***************************************************************************/
/*! \mainpage Zeus-Framework
    \section start What is Zeus about
    Zeus is an implementation of Cell Computing Model. 
    In addition, Zeus was developed on Linux, can be portable on 
    other operating systems.<BR>
    Zeus serves as Framework for the development of:
      \li dynamic and stable software
      \li modular software by use of software components
      \li distributed applications
      \li highly complex machine controls with distributed logic
      <P>See <a href="../../index.html">here for more Information</a> about Zeus-Framework.
      </P>
    \section examples Examples of Zeus
      Some examples of how to use this Framework and its classes. There are several 
      implementation using the class framework and an example how to create a
      simple framework for cell computing:
      \li <A href="../../examples/zeus_example.html">Simple Framework example (CCM based)</A>
      \li <A href="../../examples/modec_example.html">Motion detection using graphical user interface (CCM based)</A>
      \li <A href="../../examples/ga_example.html">Example for genetic behaviours (Genetic Algorithmes)</A>
      \li <A href="../../examples/serial_example.html">Serializing and streaming objects using the classes of Zeus-Framework</A>
      \li <A href="../../examples/rmi_example.html">RMI for C++ using the classes of Zeus-Framework</A>
         
*/
/***************************************************************************/

#ifndef ZeusSystemH
#define ZeusSystemH
//---------------------------------------------------------------------------
#include <zeusbase/System/Application.h>
#include <zeusbase/System/ArrayList.hpp>
#include <zeusbase/System/ByteArray.hpp>
#include <zeusbase/System/CriticalSection.h>
#include <zeusbase/System/Directory.h>
#include <zeusbase/System/Event.h>
#include <zeusbase/System/File.h>
#include <zeusbase/System/LibLoader.h>
#include <zeusbase/System/LibraryManager.h>
#include <zeusbase/System/Logger.h>
#include <zeusbase/System/LoggerManager.h>
#include <zeusbase/System/PropertyFile.h>
#include <zeusbase/System/ServerSocket.h>
#include <zeusbase/System/Socket.h>
#include <zeusbase/System/SdtLogger.h>
#include <zeusbase/System/String.h>
#include <zeusbase/System/StringList.h>
#include <zeusbase/System/StringMap.h>
#include <zeusbase/System/Thread.h>
#include <zeusbase/System/Time.h>
#include <zeusbase/System/XLoaderZObject.h>
#include <zeusbase/System/XObject.h>
#include <zeusbase/System/XObjectFactory.h>
#include <zeusbase/System/XRootZObject.h>
#include <zeusbase/System/ZObject.h>




#endif
