/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : TestModulFactory                                              *
 * Package : Test Module for Cell Computing                                *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:22:23 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: AbstractModuleSession.cpp,v $
 *   Revision 1.1  2005/10/28 12:22:23  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <zeusdev/AbstractModuleSession.h>
#include <zeusbase/System/XObjectFactory.h>
#include <zeusbase/System/LibraryManager.h>
#include <zeusbase/System/Interfaces/IXMLParser.hpp>
 
USING_NAMESPACE_Zeus

unsigned long TAbstractModuleSession::m_ulObjectCount = 0;

/***************************************************************************/
/*! Creates the TestModulFactory
*/
/***************************************************************************/
TAbstractModuleSession::TAbstractModuleSession() : TZObject()
{
  TAbstractModuleSession::m_ulObjectCount++;
  m_pZeusAPI = NULL;
}

/***************************************************************************/
/*! see IModuleSession
*/
/***************************************************************************/
void MQUALIFIER TAbstractModuleSession::initialize(IZeusAPI* api)
{
  m_pZeusAPI = api;
  if(m_pZeusAPI != NULL)
  {
    m_pZeusAPI->addRef();
  }
}



/***************************************************************************/
/*! Destroyes the TestModulFactory
*/
/***************************************************************************/
TAbstractModuleSession::~TAbstractModuleSession()
{
  m_ulObjectCount--;
  
  if (m_pZeusAPI != NULL)
  {
    m_pZeusAPI->release();
    m_pZeusAPI = NULL;
  }
}

/**************************************************************************/
/*! Memory Management
*/
/**************************************************************************/
MEMORY_MANAGER_IMPL(TAbstractModuleSession);
  INTERFACE_CAST(IModuleSession, INTERFACE_IModuleSession);
MEMORY_MANAGER_IMPL_END;

