/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : CommPipeTest                                                  *
 * Package : Test                                                          *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/16 11:37:41 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: CommPipeTest.h,v $
 *   Revision 1.1  2005/11/16 11:37:41  bhadorn
 *   Creates test classes for communication of cells
 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/  

#ifndef CommPipeTestH
#define CommPipeTestH

#include <zeusbase/CellModel/CommPipe.h>
#include <zeusbase/System/Stack.hpp>
#include <zeusbase/System/Interfaces/IXObject.hpp>
#include <cppunit/extensions/HelperMacros.h>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Test class for Naming service
*/
/***************************************************************************/
class TCommPipeTest : public CPPUNIT_NS::TestFixture
{
  CPPUNIT_TEST_SUITE( TCommPipeTest );
  CPPUNIT_TEST( test_create );
  CPPUNIT_TEST( test_lock );
  CPPUNIT_TEST( test_sendMessage );
  CPPUNIT_TEST( test_sendremote );
  CPPUNIT_TEST( test_getInfoRemote );
  CPPUNIT_TEST_SUITE_END();

  public:
    void setUp();
    void tearDown();
    
  protected:
    void test_create();
    void test_lock();
    void test_sendMessage();
    void test_sendremote();
    void test_getInfoRemote();
    
  private:
    TStack<IZUnknown*> m_lstStack;
    TStack<IXObject*> m_lstRoots;
};

END_NAMESPACE_Zeus

#endif
 
