/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : ModuleTest                                                    *
 * Package : Test                                                          *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:23:18 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: ModuleTest.h,v $
 *   Revision 1.1  2005/10/28 12:23:18  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/  

#ifndef ModuleTestH
#define ModuleTestH

#include <zeusbase/MOM/Module.h>
#include <zeusbase/System/Stack.hpp>
#include <cppunit/extensions/HelperMacros.h>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Test class for TZObject
*/
/***************************************************************************/
class TModuleTest : public CPPUNIT_NS::TestFixture
{
  CPPUNIT_TEST_SUITE( TModuleTest );
  CPPUNIT_TEST( test_create );
  CPPUNIT_TEST( test_getModule );
  CPPUNIT_TEST( test_getMode );
  CPPUNIT_TEST( test_activate );
  CPPUNIT_TEST( test_isLoaded );
  CPPUNIT_TEST( test_getModuleSession );
  CPPUNIT_TEST_SUITE_END();

  public:
    void setUp();
    void tearDown();
    
  protected:
    void test_create(); 
    void test_getModule();
    void test_getMode();
    void test_activate();
    void test_isLoaded();
    void test_getModuleSession();
    
  private:
    IModule* m_pModule; 
    IXObject* m_pBaseObject;
    TStack<IModule*> m_lstObjRef;
    TStack<IXLoaderObject*> m_lstLoaderRef;
    IModuleSession* m_pSession;
    
};

END_NAMESPACE_Zeus

#endif
 
 
 
