/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : XMLMessageTest                                                *
 * Package : Test                                                          *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:23:18 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: XMLMessageTest.h,v $
 *   Revision 1.1  2005/10/28 12:23:18  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/  

#ifndef XMLMessageTestH
#define XMLMessageTestH

#include <zeusbase/Messaging/XMLMessage.h>
#include <cppunit/extensions/HelperMacros.h>
#include <zeusbase/System/Stack.hpp>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Test class for TObjectStream
*/
/***************************************************************************/
class TXMLMessageTest : public CPPUNIT_NS::TestFixture
{
  CPPUNIT_TEST_SUITE( TXMLMessageTest );
  CPPUNIT_TEST( test_create );
  CPPUNIT_TEST( test_header );
  CPPUNIT_TEST( test_data );
  CPPUNIT_TEST( test_Interface );
  CPPUNIT_TEST_SUITE_END();

  public:
    void setUp();
    void tearDown();
    
  protected:
    void test_create(); 
    void test_header(); 
    void test_data(); 
    void test_Interface();

  private:
    TStack<IMessage*> m_lstObjRef;
    TStack<IXMLNode*> m_lstNodeRef;
};

END_NAMESPACE_Zeus

#endif
