/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : NameServerTest                                                *
 * Package : Test                                                          *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/16 11:39:50 $                                  *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: NameServerTest.h,v $
 *   Revision 1.2  2005/11/16 11:39:50  bhadorn
 *   New test added for getObjectNames()
 *
 *   Revision 1.1  2005/11/10 10:51:10  bhadorn
 *   created
 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/  

#ifndef NameServerTestH
#define NameServerTestH

#include <zeustest/Remote/RemoteTestObject.h>
#include <zeusbase/Remote/Naming.h>
#include <zeusbase/System/Stack.hpp>
#include <cppunit/extensions/HelperMacros.h>

BEGIN_NAMESPACE_Zeus

class IXObject;

/***************************************************************************/
/*! Test class for Nameserver (Skeleton of Naming service)
*/
/***************************************************************************/
class TNameServerTest : public CPPUNIT_NS::TestFixture
{
  CPPUNIT_TEST_SUITE( TNameServerTest );
  CPPUNIT_TEST( test_bind );
  CPPUNIT_TEST( test_unbind );
  CPPUNIT_TEST( test_lookupCategory );
  CPPUNIT_TEST( test_getObjectNames );
  CPPUNIT_TEST_SUITE_END();

  public:
    void setUp();
    void tearDown();
    
  protected:
    void test_bind();
    void test_unbind();
    void test_lookupCategory();
    void test_getObjectNames();
    
    void createServer();
    
  private:
    TStack<IZUnknown*> m_lstStack;
    TStack<IXObject*> m_lstRoots;
};

END_NAMESPACE_Zeus

#endif
 
