/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : NamingTest                                                    *
 * Package : Test                                                          *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/16 11:39:11 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: NamingTest.h,v $
 *   Revision 1.3  2005/11/16 11:39:11  bhadorn
 *   New test added for getObjectNames()
 *
 *   Revision 1.2  2005/11/10 10:54:03  bhadorn
 *   test for lookupCategory() method
 *
 *   Revision 1.1  2005/10/28 12:23:18  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/  

#ifndef NamingTestH
#define NamingTestH

#include <zeustest/Remote/RemoteTestObject.h>
#include <zeusbase/Remote/Naming.h>
#include <zeusbase/System/Stack.hpp>
#include <cppunit/extensions/HelperMacros.h>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Test class for Naming service
*/
/***************************************************************************/
class TNamingTest : public CPPUNIT_NS::TestFixture
{
  CPPUNIT_TEST_SUITE( TNamingTest );
  CPPUNIT_TEST( test_bind );
  CPPUNIT_TEST( test_rebind );
  CPPUNIT_TEST( test_lookup );
  CPPUNIT_TEST( test_unbind );
  CPPUNIT_TEST( test_bind2 );
  CPPUNIT_TEST( test_lookupCategory );
  CPPUNIT_TEST( test_getObjectNames );
  CPPUNIT_TEST_SUITE_END();

  public:
    void setUp();
    void tearDown();
    
  protected:
    void test_bind();
    void test_bind2();
    void test_rebind();
    void test_lookup();
    void test_unbind();
    void test_lookupCategory();
    void test_getObjectNames();
    
  private:
    TStack<IRemoteObject*> m_lstStack;
};

END_NAMESPACE_Zeus

#endif
