/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : ArrayListTest                                                 *
 * Package : Test                                                          *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/12/14 08:55:05 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: ArrayListTest.h,v $
 *   Revision 1.2  2005/12/14 08:55:05  bhadorn
 *   Tests for iterators
 *
 *   Revision 1.1  2005/10/28 12:23:47  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/  

#ifndef ArrayListTestH
#define ArrayListTestH

#include <zeusbase/System/ArrayList.hpp>
#include <zeusbase/System/Stack.hpp>
#include <cppunit/extensions/HelperMacros.h>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Test class for TStringList
*/
/***************************************************************************/
class TArrayListTest : public CPPUNIT_NS::TestFixture
{
  CPPUNIT_TEST_SUITE( TArrayListTest );
  CPPUNIT_TEST( test_create );
  CPPUNIT_TEST( test_add );
  CPPUNIT_TEST( test_remove );
  CPPUNIT_TEST( test_deleteItem );
  CPPUNIT_TEST( test_equalsItem );
  CPPUNIT_TEST( test_equals );
  CPPUNIT_TEST( test_getItem );
  CPPUNIT_TEST( test_getItemCopy );
  CPPUNIT_TEST( test_copyToList );
  CPPUNIT_TEST( test_indexOf );
  CPPUNIT_TEST( test_getArray );
  CPPUNIT_TEST( test_setArray );
  CPPUNIT_TEST( test_appendArray );
  CPPUNIT_TEST( test_copyToArray );
  CPPUNIT_TEST( test_assign );  
  CPPUNIT_TEST( test_getIterator );  
  CPPUNIT_TEST( test_getConstIterator );  
  CPPUNIT_TEST_SUITE_END();

  public:
    void setUp();
    void tearDown();
    
  protected:
    void test_create();
    void test_add();
    void test_remove();
    void test_deleteItem();
    void test_equalsItem();
    void test_equals();
    void test_getItem();
    void test_getItemCopy();
    void test_copyToList();
    void test_indexOf();
    void test_getIterator();
    void test_getConstIterator();
    
    void test_getArray();
    void test_setArray();
    void test_appendArray();
    void test_copyToArray();
    void test_assign();
    
  private:
    TStack<IListIterator<long>*> m_lstIts;
    TArrayList<long>* m_pList;
};

END_NAMESPACE_Zeus

#endif
 
