/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : EchoServer                                                    *
 * Package : Test                                                          *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/25 10:05:21 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: EchoServer.h,v $
 *   Revision 1.1  2005/11/25 10:05:21  bhadorn
 *   Created
 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/   

#ifndef EchoServerH
#define EchoServerH

#include <zeusbase/System/Thread.h>

BEGIN_NAMESPACE_Zeus

class TSocket;

/****************************************************************************/
/*! This server is used to replay allincomming data back to the client
*/
/****************************************************************************/
class TEchoServer : public TThread
{
  public:
    TEchoServer();
    
    virtual void kill();
    
  protected:
    virtual ~TEchoServer();
    virtual void execute();
    
  
  private:
    /*************************************************************************/
    /*! Client handler thread
    */
    /*************************************************************************/
    class TClientHandler : public TThread
    {
      public:
        TClientHandler(TSocket* client);
        virtual ~TClientHandler();
        virtual void execute();
        virtual void kill();
      
      protected:
        TSocket* m_pClient;
        bool m_bExit;
        
    };
  
};

END_NAMESPACE_Zeus

#endif 
