/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : NetworkInterfaceTest                                          *
 * Package : Test                                                          *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/16 11:42:53 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: NetworkInterfaceTest.h,v $
 *   Revision 1.1  2005/11/16 11:42:53  bhadorn
 *   Test for NetworkInterface class added
 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 

#ifndef NetworkInterfaceTestH
#define NetworkInterfaceTestH

#include <cppunit/extensions/HelperMacros.h>
#include <zeusbase/System/NetworkInterface.h>
#include <zeusbase/System/Stack.hpp>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Test class for TFileTest
*/
/***************************************************************************/
class TNetworkInterfaceTest : public CPPUNIT_NS::TestFixture
{
  CPPUNIT_TEST_SUITE( TNetworkInterfaceTest );
  CPPUNIT_TEST( test_getInterfaceByName );
  CPPUNIT_TEST_SUITE_END();

  public:
    void setUp();
    void tearDown();
    
  protected:
    void test_getInterfaceByName();
    
  private:
    TStack<TZObject*> m_lstObjRef;
};

END_NAMESPACE_Zeus

#endif

 
