/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : SocketTest                                                    *
 * Package : Test                                                          *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/25 10:05:21 $                                  *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: SocketTest.h,v $
 *   Revision 1.1  2005/11/25 10:05:21  bhadorn
 *   Created
 *
 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/  

#ifndef StringListTestH
#define StringListTestH

#include <zeusbase/System/ZObject.h>
#include <zeusbase/System/Stack.hpp>
#include <zeusbase/System/ByteArray.hpp>
#include <cppunit/extensions/HelperMacros.h>

BEGIN_NAMESPACE_Zeus

class TEchoServer;
class TSocket;

/***************************************************************************/
/*! Test class for TStringList
*/
/***************************************************************************/
class TSocketTest : public CPPUNIT_NS::TestFixture
{
  CPPUNIT_TEST_SUITE( TSocketTest );
  CPPUNIT_TEST( test_connect );
  CPPUNIT_TEST( test_sendData );
  CPPUNIT_TEST_SUITE_END();

  public:
    void setUp();
    void tearDown();
    
  protected:
    void test_connect();
    void test_sendData();
    
  private:
    ///Memory storage
    TStack<IZUnknown*> m_lstStack;
    TStack<TSocket*> m_lstSockets;
    ///Echoserver
    TEchoServer* m_pEchoServer;
    TString m_strAddress;
    unsigned long m_ulPort;
    
    bool sendPackage(TSocket* socket, TByteArray& data, long size);
    bool receivePackage(TSocket* socket, TByteArray& data, long size);
};

END_NAMESPACE_Zeus

#endif
 
