/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : StringTest                                                    *
 * Package : Test                                                          *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:47:13 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: StringTest.h,v $
 *   Revision 1.2  2005/11/10 10:47:13  bhadorn
 *   New test added for isEmpty()
 *
 *   Revision 1.1  2005/10/28 12:23:47  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/  

#ifndef StringTestH
#define StringTestH

#include <zeusbase/System/String.h>
#include <cppunit/extensions/HelperMacros.h>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Test class for TStringList
*/
/***************************************************************************/
class TStringTest : public CPPUNIT_NS::TestFixture
{
  CPPUNIT_TEST_SUITE( TStringTest );
  CPPUNIT_TEST( test_getSize );
  CPPUNIT_TEST( test_assign );
  CPPUNIT_TEST( test_assignStr );
  CPPUNIT_TEST( test_equals );
  CPPUNIT_TEST( test_equalsStr );
  CPPUNIT_TEST( test_concat );
  CPPUNIT_TEST( test_concatStr );
  CPPUNIT_TEST( test_getPos );
  CPPUNIT_TEST( test_transcode );
  CPPUNIT_TEST_SUITE_END();

  public:
    void setUp();
    void tearDown();
    
  protected:
    void test_getSize();
    void test_assign();
    void test_assignStr();
    void test_concat();
    void test_concatStr();
    void test_equals();   
    void test_equalsStr();  
    void test_getPos(); 
    void test_transcode();
  
};

END_NAMESPACE_Zeus

#endif
