/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : ThreadTestObject                                              *
 * Package : Test                                                          *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/11/10 10:48:54 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: ThreadTestObject.cpp,v $
 *   Revision 1.2  2005/11/10 10:48:54  bhadorn
 *   Connection accepting using acceptTO for timeout
 *
 *   Revision 1.1  2005/10/28 12:23:47  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/   

 
#include <zeustest/System/ThreadTestObject.h>
#include <zeusbase/System/LoggerManager.h>
#include <zeusbase/System/ServerSocket.h>
#include <zeusbase/System/Time.h>
#include <stdio.h>
#include <signal.h>

USING_NAMESPACE_Zeus

TThreadTestObject::TThreadTestObject() : TThread()
{}
    
TThreadTestObject::~TThreadTestObject()
{}
 

void TThreadTestObject::kill()
{
  TThread::kill();
}

void TThreadTestObject::execute()
{
  TString strAddr = L"127.0.0.1";

  TServerSocket* pServer = new TServerSocket(strAddr, 8001);
  if (pServer->bind() == RET_NOERROR)
  {
    pServer->setBlockable(false);
    //pServer->setReUsable();
    while(!this->isInterrupted())
    {
      printf(".");
      TSocket* pClient = NULL;
      if (pServer->acceptTO(&pClient, 0.2) == RET_NOERROR)
      {
        printf("Client found:\n");
        TString strAddress = pClient->getAddress();
        long lPort = pClient->getPort();
        TString strDebugOut = TString(L"Client found. [IP=") + strAddress + 
                              TString(L" Port=") + TString(lPort) + TString(L"]\n");
        printf(strDebugOut.c_str());
        pClient->disconnect();
        pClient->release();
        pClient = NULL;
      }
      else
      {
        TTime::sleep(0.1);
      }
    }
  }
  pServer->release();
}

