/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus                                                          *
 * Module  : XObjectTest                                                   *
 * Package : Test                                                          *
 * Author  : Benjamin Hadorn                                               *
 * Datum   : $Date: 2005/10/28 12:23:47 $                                                        *
 * Ablage  : $File$                                                        *
 * System  : Cell Computing Model                                          *
 ***************************************************************************
 * Aenderungen :                                                           *
 *   $Log: XObjectTest.h,v $
 *   Revision 1.1  2005/10/28 12:23:47  bhadorn
 *   *** empty log message ***
 *                                                                 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/  

#ifndef XObjectTestH
#define XObjectTestH

#include <zeusbase/System/XObject.h>
#include <zeusbase/System/Stack.hpp>
#include <cppunit/extensions/HelperMacros.h>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Test class for TXObject
*/
/***************************************************************************/
class TXObjectTest : public CPPUNIT_NS::TestFixture
{
  CPPUNIT_TEST_SUITE( TXObjectTest );
  CPPUNIT_TEST( test_getName );
  CPPUNIT_TEST( test_getID );
  CPPUNIT_TEST( test_getChildCount );
  CPPUNIT_TEST( test_getChild );
  CPPUNIT_TEST( test_getChildByName );
  CPPUNIT_TEST( test_getParent );
  CPPUNIT_TEST( test_deleteChild );
  CPPUNIT_TEST( test_getObject );
  CPPUNIT_TEST( test_getRootObject );
  CPPUNIT_TEST( test_freeze );
  CPPUNIT_TEST_SUITE_END();

  public:
    void setUp();
    void tearDown();
    
  protected:
    void test_getName();  
    void test_getID();  
    void test_getChildCount();
    void test_getChild();
    void test_getChildByName();
    void test_getParent();
    void test_deleteChild();
    void test_getObject();
    void test_getRootObject();
    void test_freeze();
    
  private:
    IXObject* m_pObject;
    TStack<IXObject*> m_lstObjRef;
};

END_NAMESPACE_Zeus

#endif
 
 
 
