/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus
 * Module  : ZVariantTest
 * Package : Test
 * Author  : Benjamin Hadorn
 * Datum   : $Date: 2005/11/10 10:50:22 $
 * Ablage  : $File$
 * System  : Cell Computing Model
 ***************************************************************************
 * Aenderungen :
 *   $Log: ZVariantTest.h,v $
 *   Revision 1.1  2005/11/10 10:50:22  bhadorn
 *   created
 *
 ***************************************************************************
 * Lizenz  :                                                               *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/  

#ifndef ZVariantTestH
#define ZVariantTestH

#include <zeusbase/System/ZVariant.h>
#include <zeusbase/System/Stack.hpp>
#include <cppunit/extensions/HelperMacros.h>

BEGIN_NAMESPACE_Zeus

/***************************************************************************/
/*! Test class for Variants
*/
/***************************************************************************/
class TZVariantTest : public CPPUNIT_NS::TestFixture
{
  CPPUNIT_TEST_SUITE( TZVariantTest );
  CPPUNIT_TEST( test_byte );
  CPPUNIT_TEST( test_long );
  CPPUNIT_TEST( test_double );
  CPPUNIT_TEST( test_string );
  CPPUNIT_TEST( test_bytearray );
  CPPUNIT_TEST( test_object );
  CPPUNIT_TEST( test_objectlist );
  CPPUNIT_TEST( test_equals );
  CPPUNIT_TEST( test_assign );
  CPPUNIT_TEST_SUITE_END();

  public:
    void setUp();
    void tearDown();
    
  protected:
    void test_byte();
    void test_long();
    void test_double();
    void test_string();
    void test_bytearray();
    void test_object();
    void test_objectlist();
    void test_equals();
    void test_assign();
    
  private:
    TStack<ISerializable*> m_lstObjRef;
    
    void createObjectList(TSingleLinkedList<ISerializable*>& list);
};

END_NAMESPACE_Zeus

#endif
 
